// This file has been written by Jiri Bittner, October 2006

#ifndef __BVHLOADER_H
#define __BVHLOADER_H

#include "Bvh.h"


namespace CHCDemo
{

/** Loader for a bounding volume hierarchy.
*/
class BvhLoader
{
public:

	Bvh *LoadFromFile(const std::string &filename, const SceneEntityContainer &entities);

protected:
	
	BvhLeaf *ImportBinLeaf(std::ifstream &stream, BvhInterior *parent);

	BvhInterior *ImportBinInterior(std::ifstream &stream, BvhInterior *parent);

	BvhNode *LoadNextNode(std::ifstream &stream, BvhInterior *parent);


};

}

#endif // __BVHLOADER_H