#include "common.h"
#include "Material.h"

namespace CHCDemo
{

RgbColor RandomColor(const float a, const float b)
{
	return RgbColor(a + Random(b), a + Random(b), a + Random(b));
}


 
Material::Material(): mId(0)
{}
  

Material::Material(const int id): mId(id)
{
}


Material::Material(const RgbColor &color):mDiffuseColor(color),
mAmbientColor(color),
mSpecularColor(0,0,0), mId(0)
{
}


int Material::GetId() const
{
	return mId;
}


Material RandomMaterial()
{
	float a = 0.1f;
	float b = 0.9f;

	Material m;
	m.mDiffuseColor = RandomColor(a, b);

	return m;
}

}
